
;===================================================================
             .MODEL  MEDIUM,BASIC
		.STACK 256
;===================================================================
                                       ;PROCEDURES TO
              
	
           EXTRN   rand:FAR
	   EXTRN   CLEAR:FAR	  ;CLEAR SCREEN
	   EXTRN   NEWLINE:FAR    ;DISPLAY NEWLINE CHARACTER
           EXTRN   GETDEC$:FAR	  ;GET 16-BIT DECIMAL FROM KBD
	   EXTRN   PUTDEC$:FAR	  ;DISPLAY 16-BIT DECIMAL INT
	   EXTRN   PUTDEC:FAR	  ;DISPLAY 16-BIT DECIMAL INT
	   EXTRN   PUTBIN:FAR	  ;DISPLAY 16BIT BINARY INT
           EXTRN   PUTOCT:FAR     ;DISPLAY 8-BIT NUMBER
	   EXTRN   PUTSTRNG:FAR   ;DISPLAY CHARACTER STRING

	 
;===================================================================
;DATA  S E G M E N T   D E F I N I T I O N
;
 	  .DATA


unsorted    Dw 100 dup (?)                                         ;these arrays should be 100 bytes - not 100 words
unsorted2   dw 100 dup (?)
unsorted3   dw 100 dup (?)
UPPER	    DW 100 ; set value for UPPER
LOWER	    DW 1    ; set value for LOWER
swaps	    db 0
countswaps  dw 0
compares    dw 0
passes      dw 0
counter     db ?	    	

	.CONST
 

SPACES      DB ' '
numswaps    DB 'Swaps: '
numcomp     DB '/ Compares: '
numpasses   DB '/ Passes: '
;===================================================================
;C O D E   S E G M E N T   D E F I N I T I O N
;
            .CODE
	    ASSUME  DS:DGROUP
;===================================================================
MAIN PROC

        MOV     AX,DGROUP     ;SET DS-REGISTER TO POINT TO
        MOV     DS,AX               ;CONSTANT DATA SEGMENT
	MOV     ES,AX	   ;SET ES-REGISTER
	CALL    CLEAR
	
START:
	MOV BX,OFFSET UNSORTED ;set BX as base for unsorted             put this just before the call to sort3
	
RAND_NUM:
	MOV  CX,100	;get 100 random numbers seed 5555h 
        MOV sI,0
CREATE_ARR:
	
	push CX
        MOV  AX,UPPER    ;MOVE UPPER IN AX REGISTER 9999
        PUSH AX         ; PUSH AX VALUE INTO THE STACK
	MOV  AX,LOWER    ;MOVE LOWER IN AX REGISTER 0
	PUSH AX		;PUSH AX VALUE INTO THE STACK
	
	CALL RAND	;CALL PROC RANDOM
        MOV  unsorted[SI],AX        ;first array                       make these AL - we will just use the low byte
        MOV  unsorted2[SI],AX       ;second array
	MOV  unsorted3[SI],AX       ;third array

	ADD SI,2                                                         make this inc si

;you can fill the array with words - in fact, it is cooler that way
;but, i want to compare the number of swaps and compares against Veronica's program
;she uses only the low byte from RAND, 100 times
;it would be "smoother" to use the whole word, 50 times instead
;but in order to compare numbers, the data in the arrays needs to be the same
	
	pop cx
	loop create_arr  ;loop 100 times to get 100 rand numb
	
;i would make a routine called "ResetVals" in that routine, you could set the swaps, compares, passes to 0
;then, each at the beginning of each routine, just call ResetVals

;also i would do this for each sort...
;
;1) mov bx,offset (appropriate array name)
;2) mov cx,100 or mov cx,sizeof (same array name) (size in bytes)
;3) call the sort routine
;4) call printresults (combine the array display and "stat" routines into one proc)
;
;repeat the above 3 times (once for each sort)
;that would look nice and neat
	
        call print	;Print random numbers
	CALL bublesort1
	call print	;print sorted using Bub1
	CALL PRINTSTAT
	CALL BUBLESORT2	
	CALL PRINT	;print sorted using bub2
	CALL PRINTSTAT
	CALL BUBLESORT3
	CALL PRINT	;print sorted using bub3
	CALL PRINTSTAT

	jmp endd

PRINT PROC NEAR
	
	call newline
	MOV  SI,0
        MOV  COUNTER,100	;SET LOOP COUNTS 0 to 100
NUM_LOOP:
	MOV  CX,25	;SET TO LOOP 10 numbers per line 
PRINTT:
        
	PUSH CX
	MOV AX,[bx+SI]
	ADD SI,2
	CALL PUTDEC
	LEA     DI,OFFSET spaces   ; PROMPT FOR 16BIT DEC NUMBER
        MOV     CX,SIZEOF spaces
	CALL    PUTSTRNG
	pop cx
	loop printt
	call newline
	SUB counter,25
	cmp counter,0
	JNZ NUM_LOOP
	
	ret ;go back to where we came from
print	ENDP
	
PRINTSTAT proc near
	
print_stat:
	
	LEA     DI,OFFSET numswaps   ; PROMPT FOR 16BIT DEC NUMBER
        MOV     CX,SIZEOF numswaps
	CALL    PUTSTRNG	
	mov AX,countswaps
	call putdec$
	LEA     DI,OFFSET spaces   ; PROMPT FOR 16BIT DEC NUMBER
        MOV     CX,SIZEOF spaces
	CALL    PUTSTRNG
	LEA     DI,OFFSET numcomp   ; PROMPT FOR 16BIT DEC NUMBER
        MOV     CX,SIZEOF numcomp
	CALL    PUTSTRNG		
	mov aX,compares
	call putdec$
	LEA     DI,OFFSET spaces   ; PROMPT FOR 16BIT DEC NUMBER
        MOV     CX,SIZEOF spaces
	CALL    PUTSTRNG
	LEA     DI,OFFSET numpasses   ; PROMPT FOR 16BIT DEC NUMBER
        MOV     CX,SIZEOF numpasses
	CALL    PUTSTRNG		
	mov aX,passes
	call putdec$
	
ret ;go back to where we came from
printSTAT	ENDP



bublesort1 proc near
		
	MOV CX,100
	Dec cx 	   ;last element not compared
        shl cx,1

mainloop: 
	Mov si,0 ;initialize array index to zero
     	Mov  swaps,0   ;rest swap flage to no swap

innerloop: 
	Mov ax,[bx+si] 		;load number in ax
	cmp ax,[bx+si+2] ;compare with next number
	jbe noswap 	;no swap if already in order

;----------------------------------------------
	mov dx,[bx+si+2]   ;load second element in dx
	mov [bx+si],dx 	;store first nuber in second
	mov [bx+si+2],ax ;store second numberin first
	mov swaps,1 	;flag that a swap has been done
	add countswaps,1
noswap: 
	add compares,1
	Add si,2 	;advance si to next index
	cmp si,cx 	;are we at last index
	jb innerloop 	;if not cmpare next two
;------------------------------------------------
	add passes,1
	cmp swaps,1 	;check if a swap has been done
	je  mainloop 	;if yes make another pass


	ret ;go back to where we came from
bublesort1	ENDP	
;===================================================

bublesort2 proc near

	MOV BX,OFFSET UNSORTED2
	mov countswaps,0
	mov compares,0
	mov passes,0
	MOV CX,100
	Dec cx 	   ;last element not compared
        shl cx,1

mainloop: 
	Mov si,0 ;initialize array index to zero
     	Mov  swaps,0   ;rest swap flage to no swap

innerloop: 
	Mov ax,[bx+si] 		;load number in ax
	cmp ax,[bx+si+2] ;compare with next number
	jbe noswap 	;no swap if already in order

;----------------------------------------------
	mov dx,[bx+si+2]   ;load second element in dx
	mov [bx+si],dx 	;store first nuber in second
	mov [bx+si+2],ax ;store second numberin first
	mov swaps,1 	;flag that a swap has been done
	add countswaps,1
noswap: 
	add compares,1
	Add si,2 	;advance si to next index
	cmp si,cx 	;are we at last index
	jb innerloop 	;if not cmpare next two
;--------------------------------------------------
	sub cx,2
	add passes,1
	cmp swaps,1 	;check if a swap has been done
	je  mainloop 	;if yes make another pass

	
	ret ;go back to where we came from
bublesort2	ENDP

;====================================================

bublesort3 proc near
	
	MOV BX,OFFSET UNSORTED3
	mov countswaps,0
	mov compares,0
	mov passes,0
	MOV CX,100
	Dec cx 	   ;last element not compared
        shl cx,1
	Mov si,0 ;initialize array index to zero
	mov di,0
mainloop: 
	
     	Mov  swaps,0   ;rest swap flage to no swap

innerloop: 
	Mov ax,[bx+si] 		;load number in ax
	cmp ax,[bx+si+2] ;compare with next number
	jbe noswap 	;no swap if already in order

;----------------------------------------------
	mov dx,[bx+si+2]   ;load second element in dx
	mov [bx+si],dx 	;store first nuber in second
	mov [bx+si+2],ax ;store second numberin first
	mov swaps,1 	;flag that a swap has been done
	add countswaps,1
noswap: 
	add compares,1
	Add si,2 	;advance si to next index
	cmp si,cx 	;are we at last index
	jb innerloop 	;if not cmpare next two
;============================================================
	sub cx,2
	sub si,2
	cmp swaps,0 	;check if a swap has been done
	je  endb 	;if yes make another pass
backward:
	mov ax,[bx+si]
	cmp ax,[bx+si-2]
	jae noswapb
;============================================================
	mov dx,[bx+si-2]   ;load second element in dx
	mov [bx+si],dx 	;store first nuber in second
	mov [bx+si-2],ax ;store second numberin first
	mov swaps,1 	;flag that a swap has been done
	add countswaps,1
noswapb:
	add compares,1
	sub si,2
	cmp si,di
	ja backward
	add di,2
	mov si,di
	add passes,2
	cmp swaps,1
	je mainloop

	
endb:

	ret ;go back to where we came from
bublesort3	ENDP





	

ENDD:	

.exit
MAIN ENDP                        
        END MAIN


